// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2017 Thomas Klose & Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.IO;
using System.Threading;
using System.Xml;

using Hiperscan.Unix;


namespace Hiperscan.Extensions.ApoIdent
{
    public partial class Configurations
    {
        public abstract class Preferences<T> where T : Preferences<T>
        {
            public Preferences()
            {
                this.Init();
            }

            public Preferences(XmlNode parent_node) : this()
            {
                this.Init(parent_node);
            }

            protected virtual void Init(XmlNode parent_node = null)
            {
                if (parent_node != null)
                    this.Read(parent_node);
            }

            public virtual void Stash()
            {
                this.Stashed = this.Clone();
                this.HasChanges = false;
            }

            public virtual void Unstash()
            {
                this.HasChanges = this.SettingsChanged();
                this.Stashed = null;
            }

            public bool HasChanges { get; set; }

            public abstract void WriteToXml(XmlDocument doc, XmlNode parent);
            public abstract T Clone();
            protected T Stashed { get; set; }
            protected abstract bool SettingsChanged();

            protected abstract void Read(XmlNode parent_node = null);
            public bool ForceWriting { get; set; } = false;
        }
    }
}
